/*
 * Copyright 2012-2014 David Karnok
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package hu.akarnokd.utils.xml;

import edu.umd.cs.findbugs.annotations.NonNull;

/**
 * Common interface to denote objects which can be serialized and deserialized into XElements.
 * @author akarnokd, Jul 6, 2011
 */
public interface XNSerializable {
	/**
	 * Load the contents from the given source.
	 * @param source the source XElement
	 */
	void load(@NonNull XNElement source);
	/**
	 * Save the contents into the given destination.
	 * @param destination the destination XElement
	 */
	void save(@NonNull XNElement destination);
}
